/*

Copyright _ 2005, dana 'mania'
riverrunner@gmail.com
if you have any suggestions or improvements for this widget please let me know.

*/

//// GLOBAL VARS ////

// global vars for computer
var computer_shotsfired = 0;
var computer_misses = 0;
var computer_sinks = 0;
var computer_hitcount = [0,0,0,0,0];
var computer_whatsunk = [false,false,false,false,false];
var computer_array = [['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n']];

// global vars for human
var human_shotsfired = 0;
var human_misses = 0;
var human_sinks = 0;
var human_hitcount = [0,0,0,0,0];
var human_whatsunk = [false,false,false,false,false];
var human_placedcount = [0,0,0,0,0];
var human_placed = 0;
var human_workingship = -1;

var human_array = [['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n'],
['n','n','n','n','n','n','n','n','n','n']];

// global vars for boats
var boats = [5,4,3,3,2];
var boatnames = ['s','c','d','k','p'];
var boatdesc = ['SEA KAYAK','CANOE','DUCKIE','CREEKBOAT','PLAYBOAT'];

// other globals
var gamestarted = false;
var gameover = false;
var whosturn = "human";
var letters = ['A','B','C','D','E','F','G','H','I','J'];
var elementid = "";
var lasthitrow = -1;
var lasthitcol = -1;
var newhit = false;
var sinkmode = false;
var oe = randy(2); //odd or even

//// FUNCTIONS ////

// get a random number
function randy(maxplusone) {
	ran = Math.floor(Math.random() * (maxplusone));
	return ran;
}
// computer places its ships
function computer_placeships() {
	var row = 0;
	var col = 0;
	var ori = 0; // 0 = up, 1 = rt, 2 = dn, 3 = lt
	var countme = 0;
	var isok = true;
	// place each boat, starting with the biggest boat.
	for (var i=0; i<boats.length; i++) {
		isok = true;
		row = randy(10);
		col = randy(10);
		// find a random orientation
		ori = randy(4);
		// see if we can go that way
		if (computer_array[row][col] == 'n') {
			for (var b=0; b<boats[i]; b++) {
				switch(ori) {
					case 0:
						if (row - boats[i] > -1) {
							if (computer_array[row-b][col] != 'n') {
								isok = false;
							}
						} else {
							isok = false;
						}
					break;
					case 1:
						if (col + boats[i] < 11) {
							if (computer_array[row][col+b] != 'n') {
								isok = false;
							}
						} else {
							isok = false;
						}
					break;
					case 2:
						if (row + boats[i] < 11) {
							if (computer_array[row+b][col] != 'n') {
								isok = false;
							}
						} else {
							isok = false;
						}
					break;
					case 3:
						if (col - boats[i] > -1) {
							if (computer_array[row][col-b] != 'n') {
								isok = false;
							}
						} else {
							isok = false;
						}
					break;
				} 
			}
		} else {
			isok = false;
		}
		if (isok == true) {
			for (var b=0; b<boats[i]; b++) {
				switch(ori) {
					case 0:
						computer_array[row-b][col] = i;
						elementid = (row-b)+""+col+"";
					break;
					case 1:
						computer_array[row][col+b] = i;
						elementid = row+""+(col+b)+"";
					break;
					case 2:
						computer_array[row+b][col] = i;
						elementid = (row+b)+""+col+"";
					break;
					case 3:
						computer_array[row][col-b] = i;
						elementid = row+""+(col-b)+"";
					break;
				}
			}
		} else {
			i--; // try again
			countme++;
		}
	}
}
// computer fires
function computer_shoots() {
	if (gamestarted == true && gameover == false && whosturn == 'computer') {
		// hunt for hits but not sunk
		var row = -1;
		var col = -1;
		var human_hitrow = new Array();
		var human_hitcol = new Array();
		var j=0;
		var ugstring = '';
		sinkmode = false;
		for (var r=0; r<10; r++) {
			for (var c=0; c<10; c++) {
				if (human_array[r][c] == 's' || human_array[r][c] == 'c' || human_array[r][c] == 'k' || human_array[r][c] == 'd' || human_array[r][c] == 'p') {
					sinkmode = true;
					human_hitrow[j] = r;
					human_hitcol[j] = c;
					j++;
				}
			}
		}
		if (sinkmode == true) {
			// find all possible shots near hits then pick the best one
			var human_nextrow = new Array();
			var human_nextcol = new Array();
			var q = 0;
			var qindex = -1;
			var newrow = -1;
			var newcol = -1;
			var showcol = 0;
			for (var k=0; k<human_hitrow.length; k++) {
				for (var d=0; d<4; d++) {
					switch(d) {
						case 0:
							if (parseInt(human_hitrow[k]) > 0) {
								newrow = parseInt(human_hitrow[k])-1;
								newcol = parseInt(human_hitcol[k]);
								if ((human_array[newrow][newcol]) == 'n' || (human_array[newrow][newcol]) < 5) {
									human_nextrow[q] = newrow;
									human_nextcol[q] = newcol;
									q++;
								}
							}
						break;
						case 1:
							if (parseInt(human_hitcol[k]) < 9) {
								newrow = parseInt(human_hitrow[k]);
								newcol = parseInt(human_hitcol[k])+1;
								if ((human_array[newrow][newcol]) == 'n' || (human_array[newrow][newcol]) < 5) {
									human_nextrow[q] = newrow;
									human_nextcol[q] = newcol;
									q++;
								}
							}
						break;
						case 2:
							if (parseInt(human_hitrow[k]) < 9) {
								newrow = parseInt(human_hitrow[k])+1;
								newcol = parseInt(human_hitcol[k]);
								if ((human_array[newrow][newcol]) == 'n' || (human_array[newrow][newcol]) < 5) {
									human_nextrow[q] = newrow;
									human_nextcol[q] = newcol;
									q++;
								}
							}
						break;
						case 3:
							if (parseInt(human_hitcol[k]) > 0) {
								newrow = parseInt(human_hitrow[k]);
								newcol = parseInt(human_hitcol[k])-1;
								if ((human_array[newrow][newcol]) == 'n' || (human_array[newrow][newcol]) < 5) {
									human_nextrow[q] = newrow;
									human_nextcol[q] = newcol;
									q++;
								}
							}
						break;
					}
				}
				
			}
			// now take a shot
			// try patterns first
			if (human_hitrow[0] == human_hitrow[1]) { // similar rows
				for (var hr=0; hr<human_nextrow.length; hr++) {
					if (human_nextrow[hr] == human_hitrow[0]) {
						qindex = hr;
						break;
					}
				}
			} else if (human_hitcol[0] == human_hitcol[1]) { // similar rows
				for (var hr=0; hr<human_nextcol.length; hr++) {
					if (human_nextcol[hr] == human_hitcol[0]) {
						qindex = hr;
						break;
					}
				}
			}
			if (qindex == -1) {
				qindex = randy(human_nextrow.length);
			}
			
			row = human_nextrow[qindex];
			col = human_nextcol[qindex];
			
		} else { // find a random row and col within parameters
			sinkmode = false;
			var human_choicerow = new Array();
			var human_choicecol = new Array();
			var s = 0;
			var x = 0;
			var xindex = -1;
			if (oe == 0) {
				t = 1;
			} else {
				t = 0;
			}
			for (var r=0; r<10; r++) {
				if (Math.floor(r/2)*2 == r) { // row is even
					s = oe;
				} else { // row is odd
					s = t;
				}
				for (var c=s; c<10; c=c+2) {
					if ((human_array[r][c]) == 'n' || (human_array[r][c]) < 5) {
						human_choicerow[x] = r;
						human_choicecol[x] = c;
						x++;
					}
				}
			}
			xindex = randy(human_choicerow.length);
			row = human_choicerow[xindex];
			col = human_choicecol[xindex];
		}

		elementid = "my"+row+""+(col)+"";
		computer_shotsfired++;
		if (human_array[row][col] != 'n') { // computer hits human boat
			var i = human_array[row][col];
			human_hitcount[i]++;
			human_array[row][col] = boatnames[i]; // mark as shot and hit
			document.getElementById(elementid).src = 'images/square_hit.png';
			if (human_hitcount[i] == boats[i]) { // computer sinks human boat
				human_sinks++;
				human_whatsunk[i] = true;
				// replace sunk boat with x
				for (var r=0; r<10; r++) {
					for (var c=0; c<10; c++) {
						if (human_array[r][c] == boatnames[i]) {
							human_array[r][c] = 'x'; // for sunk
						}
					}
				}
				document.getElementById('human').innerHTML = 'I SUNK YOUR '+boatdesc[i];
				document.getElementById('humanboat_'+i).src = "images/"+i+"_sunk.png";
				if (human_sinks == 5) {
					gameover = true;
					document.getElementById('computer').innerHTML = 'COMPUTER WINS<br />SHOTS: '+computer_shotsfired+'<br />MISSES: '+computer_misses;
					document.getElementById('human').innerHTML = '<input type="button" value="NEW GAME" onclick="newgame();" />';
				}
			} else { // normal hit
				showcol = parseInt(col)+1;
				document.getElementById('human').innerHTML = 'HIT '+letters[row]+':'+showcol;
			}
			// remember hit
			lasthitrow = row;
			lasthitcol = col;
		} else { // computer misses human
			human_array[row][col] = 'm'; // mark as shot and missed
			showcol = parseInt(col)+1;
			document.getElementById('human').innerHTML = 'MISS '+letters[row]+':'+showcol;
			document.getElementById(elementid).src = 'images/square_miss.png';
			computer_misses++;
		}

		whosturn = 'human';
	}
}
// starts the game
function startgame() {
	gamestarted = true;
	if (whosturn == 'human') {
		document.getElementById('computer').innerHTML = 'YOUR TURN';
		document.getElementById('human').innerHTML = '';
	}
}
// newgame
function newgame() {
	location.href='paddleship.html';
}
// human fires
function human_shoots(row,col) {
	if (gamestarted == true && gameover == false && whosturn == 'human') {
		if (computer_array[row][col] == 'n' || computer_array[row][col] < 5) {
			var showcol = 0;
			human_shotsfired++;
			elementid = row+""+(col)+"";
			if (computer_array[row][col] != 'n') {
				var i = computer_array[row][col];
				computer_hitcount[i]++;
				computer_array[row][col] = boatnames[i]; // mark as shot and hit
				document.getElementById(elementid).src = 'images/square_hit.png';
				if (computer_hitcount[i] == boats[i]) {
					computer_sinks++;
					computer_whatsunk[i] = true;
					// replace sunk boat with x
					for (var r=0; r<10; r++) {
						for (var c=0; c<10; c++) {
							if (computer_array[r][c] == boatnames[i]) {
								computer_array[r][c] = 'x'; // for sunk
							}
						}
					}
					document.getElementById('computer').innerHTML = 'YOU SUNK MY '+boatdesc[i];
					document.getElementById(boatnames[i]).src = "images/"+i+"_sunk.png";
					if (computer_sinks == 5) {
						gameover = true;
						document.getElementById('computer').innerHTML = 'HUMAN WINS<br />SHOTS: '+human_shotsfired+'<br />MISSES: '+human_misses;
						document.getElementById('human').innerHTML = '<input type="button" value="NEW GAME" onclick="newgame();" />';
					}
				} else {
					showcol = parseInt(col)+1;
					document.getElementById('computer').innerHTML = 'HIT '+letters[row]+':'+showcol;
				}
			} else {
				computer_array[row][col] = 'm'; // mark as shot and missed
				showcol = parseInt(col)+1;
				document.getElementById('computer').innerHTML = 'MISS '+letters[row]+':'+showcol;
				document.getElementById(elementid).src = 'images/square_miss.png';
				human_misses++;
			}
			whosturn = 'computer';
			computer_shoots();
		}
	}
}
// human player places ship
function human_placeships(myindex) {
	var warning = '';
	var i = parseInt(myindex);
	var row = 0;
	var col = 0;
	var ori = 1; // 0 = up, 1 = rt, 2 = dn, 3 = lt
	var isok = true;
	var rowindex = document.getElementById('hrow').selectedIndex;
	var row = parseInt(document.getElementById('hrow').options[rowindex].value);
	var colindex = document.getElementById('hcol').selectedIndex;
	var col = parseInt(document.getElementById('hcol').options[colindex].value);
	var oriindex = document.getElementById('hori').selectedIndex;
	var ori = parseInt(document.getElementById('hori').options[oriindex].value);
	// they must want to move their ship before they start the game
	if (human_placedcount[i] > 0) {
		for (var r=0; r<10; r++) {
			for (var c=0; c<10; c++) {
				if (human_array[r][c] == i) {
					human_array[r][c] = 'n';
					elementid = "my"+r+""+c+"";
					document.getElementById(elementid).src = 'images/square.png';
				}
			}
		}
		human_placedcount[i]--;
		human_placed--;
	}
	// see if we can go that way
	if (human_array[row][col] == 'n') {
		for (var b=0; b<boats[i]; b++) {
			switch(ori) {
				case 0:
					if (row - boats[i] > -1) {
						if (human_array[row-b][col] != 'n') {
							isok = false;
						}
					} else {
						isok = false;
					}
				break;
				case 1:
					if (col + boats[i] < 11) {
						if (human_array[row][col+b] != 'n') {
							isok = false;
						}
					} else {
						isok = false;
					}
				break;
				case 2:
					if (row + boats[i] < 11) {
						if (human_array[row+b][col] != 'n') {
							isok = false;
						}
					} else {
						isok = false;
					}
				break;
				case 3:
					if (col - boats[i] > -1) {
						if (human_array[row][col-b] != 'n') {
							isok = false;
						}
					} else {
						isok = false;
					}
				break;
			} 
		}
	} else {
		isok = false;
	}
	if (isok == true) {
		for (var b=0; b<boats[i]; b++) {
			switch(ori) {
				case 0:
					human_array[row-b][col] = i;
					elementid = "my"+(row-b)+""+col+"";
				break;
				case 1:
					human_array[row][col+b] = i;
					elementid = "my"+row+""+(col+b)+"";
				break;
				case 2:
					human_array[row+b][col] = i;
					elementid = "my"+(row+b)+""+col+"";
				break;
				case 3:
					human_array[row][col-b] = i;
					elementid = "my"+row+""+(col-b)+"";
				break;
			}
			document.getElementById(elementid).src = 'images/square_black.png';
			human_placedcount[i]++;
		}
		human_placed++;
		document.getElementById('humanboat_'+i).src = 'images/'+i+'_black.png';
	} else {
		// try again
		warning = 'INVALID! TRY AGAIN.';
	}
	if (human_placed == 5) {
		document.getElementById('human').innerHTML = '<input type="button" value="START" onclick="startgame();" />';
	} else {
		document.getElementById('human').innerHTML = warning+'<br />PLACE YOUR BOATS<br />&darr;';
	}
	human_workingship = -1;
}
// mousover dots
function letters_over(who,r,c) {
	var rid = who+"_r_"+r;
	var cid = who+"_c_"+c;
	document.getElementById(rid).style.color = '#000';
	document.getElementById(rid).style.backgroundColor = '#FFF';
	document.getElementById(cid).style.color = '#000';
	document.getElementById(cid).style.backgroundColor = '#FFF';
}
function letters_out(who,r,c) {
	var rid = who+"_r_"+r;
	var cid = who+"_c_"+c;
	document.getElementById(rid).style.color = '#51C3A4';
	document.getElementById(rid).style.backgroundColor = '';
	document.getElementById(cid).style.color = '#51C3A4';
	document.getElementById(cid).style.backgroundColor = '';
}
// human player mousover ship
function mousin(elementid) {
	if (gamestarted == false && gameover == false) {
		var i = elementid.slice(-1);
		document.getElementById(elementid).src = 'images/'+i+'_sunk.png';
	}
}
// human player mouseout ship
function mousou(elementid) {
	if (gamestarted == false && gameover == false) {
		var i = elementid.slice(-1);
		if (human_placedcount[i] > 0 && human_workingship != i) {
			document.getElementById(elementid).src = 'images/'+i+'_black.png';
		}
		if (human_placedcount[i] == 0 && human_workingship != i) {
			document.getElementById(elementid).src = 'images/'+i+'.png';
		}
	}
}
// human player click ship
function clicky(elementid) {
	if (gamestarted == false && gameover == false) {
		var i = elementid.slice(-1);
		human_workingship = i;
		document.getElementById(elementid).src = 'images/'+i+'_sunk.png';
		document.getElementById('human').innerHTML = boatdesc[i]+'<br /><select name="hrow" id="hrow"><option value="0">A</option><option value="1">B</option><option value="2">C</option><option value="3">D</option><option value="4">E</option><option value="5">F</option><option value="6">G</option><option value="7">H</option><option value="8">I</option><option value="9">J</option></select><select name="hcol" id="hcol"><option value="0">1</option><option value="1">2</option><option value="2">3</option><option value="3">4</option><option value="4">5</option><option value="5">6</option><option value="6">7</option><option value="7">8</option><option value="8">9</option><option value="9">10</option></select><br /><select name="hori" id="hori"><option value="1">&rarr;</option><option value="2">&darr;</option><option value="3">&larr;</option><option value="0">&uarr;</option></select><input type="button" value="PLACE" onclick="human_placeships('+i+');" />';
	}
}

// -------------------------------------------------------------------

// Anything below this point was taken from Apple's pref/flip routines

// -------------------------------------------------------------------

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
	
	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);

	document.getElementById('fliprollie').style.display = 'none';
}


function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
	
	back.style.display="none";
	front.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}


function makeKey(key)
{
	return (widget.identifier + "-" + key);
}


function removed()
{

	widget.setPreferenceForKey(null,makeKey("worldString"));
}


function focused()
{
	document.getElementById('worldText').style.color = 'white'; 
}


function blurred()
{
	document.getElementById('worldText').style.color = 'gray'; 
}


if(window.widget)
{
	widget.onremove = removed;
	window.onfocus = focused;
	window.onblur = blurred;
}	


var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


function mousemove (event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}


function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}


function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}


function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}


function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}